Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/FeatureSetProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/FeatureSetProvider.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/FeatureSetProvider.java	(revision 43377)
@@ -25,6 +25,7 @@
 package org.gvsig.fmap.dal.feature.spi;
 
 import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.feature.FeatureType;
 import org.gvsig.tools.dispose.Disposable;
 import org.gvsig.tools.dispose.DisposableIterator;
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/spi/DataManagerProviderServices.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/spi/DataManagerProviderServices.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/spi/DataManagerProviderServices.java	(revision 43377)
@@ -33,6 +33,7 @@
 import org.gvsig.fmap.dal.Register;
 import org.gvsig.fmap.dal.exception.InitializeException;
 import org.gvsig.fmap.dal.exception.ProviderNotRegisteredException;
+import org.gvsig.fmap.dal.feature.EditableFeatureType;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.feature.FeatureType;
@@ -148,5 +149,5 @@
      * @return
      */
     public InputStream getResourceAsStream(Object resourcesLoader, String name);
-    
+
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureType.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureType.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureType.java	(revision 43377)
@@ -27,11 +27,10 @@
 import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.Collections;
-import java.util.HashSet;
 import java.util.Iterator;
 import java.util.List;
-import java.util.Set;
 import org.apache.commons.lang3.ArrayUtils;
+import org.apache.commons.lang3.StringUtils;
 
 import org.cresques.cts.IProjection;
 
@@ -75,6 +74,9 @@
 	private List srsList = null; 
 
 	protected DefaultFeatureType(String id) {
+        if( StringUtils.isEmpty(id) ) {
+            id = "default";
+        }
 		this.internalID = Integer.toHexString((int) (Math.random()*100000)).toUpperCase();
 		this.id = id;
 		this.rules = new DefaultFeatureRules();
@@ -87,17 +89,17 @@
 	}
 
 	protected DefaultFeatureType() {
-		this("default");
+		this((String)null);
 	}
 
 	protected DefaultFeatureType(DefaultFeatureType other) {
-		this("default");
+		this((String)null);
 		initialize(other, true);
 	}
 
 	protected DefaultFeatureType(DefaultFeatureType other,
 			boolean copyAttributes) {
-		this("default");
+		this((String)null);
 		initialize(other, copyAttributes);
 	}
         
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureStore.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureStore.java	(revision 43376)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureStore.java	(revision 43377)
@@ -387,7 +387,9 @@
         }
         this.notifyChange(DataStoreNotification.BEFORE_DISPOSE);
         this.disposeIndexes();
-        this.provider.dispose();
+        if( this.provider!=null ) {
+            this.provider.dispose();
+        }
         if (this.selection != null) {
             this.selection.dispose();
             this.selection = null;
@@ -1147,6 +1149,9 @@
     private void disposeIndexes() {
         FeatureIndexes theIndexes = getIndexes();
         LOG.debug("Disposing indexes: {}", theIndexes);
+        if( theIndexes==null ) {
+            return;
+        }
         for (Iterator iterator = theIndexes.iterator(); iterator.hasNext();) {
             FeatureIndex index = (FeatureIndex) iterator.next();
             if (index instanceof FeatureIndexProviderServices) {
@@ -1410,7 +1415,9 @@
                 throw new NeedEditingModeException(this.getName());
 
             case MODE_APPEND:
-                ((FeatureSelection) this.getSelection()).deselectAll();
+                if( selection!=null ) {
+                    selection = null;
+                }
                 notifyChange(FeatureStoreNotification.BEFORE_FINISHEDITING);
                 provider.endAppend();
                 exitEditingMode();
@@ -1422,11 +1429,9 @@
                 if (hasStrongChanges && !this.allowWrite()) {
                     throw new WriteNotAllowedException(getName());
                 }
-
-                if(featureManager.isSelectionCompromised()) {
-                    ((FeatureSelection) this.getSelection()).deselectAll();
-                };
-
+                if(featureManager.isSelectionCompromised() && selection!=null ) {
+                    selection = null;
+                }
                 notifyChange(FeatureStoreNotification.BEFORE_FINISHEDITING);
                 if (hasStrongChanges) {
                     validateFeatures(Feature.FINISH_EDITING);
@@ -2101,7 +2106,7 @@
 
     @Override
     public EditableFeatureType createFeatureType() {
-        DefaultEditableFeatureType ftype = new DefaultEditableFeatureType();
+        EditableFeatureType ftype = this.dataManager.createFeatureType();
         return ftype;
     }
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialExplorerParameters.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialExplorerParameters.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialExplorerParameters.java	(revision 43377)
@@ -0,0 +1,74 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+*
+* Copyright (C) 2007-2008 Infrastructures and Transports Department
+* of the Valencian Government (CIT)
+*
+* This program is free software; you can redistribute it and/or
+* modify it under the terms of the GNU General Public License
+* as published by the Free Software Foundation; either version 2
+* of the License, or (at your option) any later version.
+*
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+*
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+* MA  02110-1301, USA.
+*
+ */
+/**
+ *
+ */
+package org.gvsig.fmap.dal.store.h2;
+
+import java.io.File;
+import java.util.Properties;
+import org.gvsig.fmap.dal.exception.ValidateDataParametersException;
+import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
+
+public class H2SpatialExplorerParameters extends
+        JDBCServerExplorerParameters 
+    implements
+        H2SpatialConnectionParameters
+    {
+    
+    private final H2SpatialConnectionParametersHelper helper;
+
+    public H2SpatialExplorerParameters() {
+        super(
+                H2SpatialLibrary.NAME + "ServerExplorerParameters",
+                H2SpatialLibrary.NAME
+        );
+        this.helper = new H2SpatialConnectionParametersHelper(this);
+    }
+
+    @Override
+    public String getUrl() {
+        return this.helper.getUrl();
+    }
+    
+    @Override
+    public void validate() throws ValidateDataParametersException {
+        this.helper.validate();
+        super.validate();
+    }
+
+    @Override
+    public Properties getProperties() {
+        return this.helper.getProperties();
+    }
+
+    @Override
+    public File getFile() {
+        return this.helper.getFile();
+    }
+    
+    @Override
+    public void setFile(File database) {
+        this.helper.setFile(database);
+    }
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialLibrary.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialLibrary.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialLibrary.java	(revision 43377)
@@ -0,0 +1,98 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+ *
+ * Copyright (C) 2007-2008 Infrastructures and Transports Department
+ * of the Valencian Government (CIT)
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ */
+package org.gvsig.fmap.dal.store.h2;
+
+import org.gvsig.fmap.dal.DALLibrary;
+import org.gvsig.fmap.dal.DALLocator;
+import org.gvsig.fmap.dal.spi.DataManagerProviderServices;
+import org.gvsig.fmap.dal.store.db.DBHelper;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCLibrary;
+import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCStoreProviderBase;
+import org.gvsig.metadata.exceptions.MetadataException;
+import org.gvsig.tools.library.AbstractLibrary;
+import org.gvsig.tools.library.LibraryException;
+
+public class H2SpatialLibrary extends AbstractLibrary {
+
+    public static final String NAME = "H2Spatial";
+
+    @Override
+    public void doRegistration() {
+        registerAsServiceOf(DALLibrary.class);
+        require(JDBCLibrary.class);
+    }
+
+    @Override
+    protected void doInitialize() throws LibraryException {
+    }
+
+    @Override
+    protected void doPostInitialize() throws LibraryException {
+        LibraryException ex = null;
+
+        DataManagerProviderServices dataman = 
+                (DataManagerProviderServices) DALLocator.getDataManager();
+
+        try {
+            Class.forName(H2SpatialHelper.H2SpatialJDBCDriver);
+        } catch(Throwable th) {
+            H2SpatialHelper.logger.warn("Can't load H2Spatial JDBC Driver.",th);
+        }
+        
+        DBHelper.registerParametersDefinition(
+                NAME + "StoreParameters",
+                H2SpatialStoreParameters.class,
+                dataman.getResourceAsStream(this, NAME + "Parameters.xml")
+        );
+        DBHelper.registerParametersDefinition(
+                NAME + "NewStoreParameters",
+                H2SpatialNewStoreParameters.class,
+                dataman.getResourceAsStream(this, NAME + "Parameters.xml")
+        );
+        DBHelper.registerParametersDefinition(
+                NAME + "ServerExplorerParameters",
+                H2SpatialExplorerParameters.class,
+                dataman.getResourceAsStream(this, NAME + "Parameters.xml")
+        );
+        try {
+            DBHelper.registerMetadataDefinition(
+                NAME,
+                JDBCStoreProviderBase.class,
+                dataman.getResourceAsStream(this, NAME + "Metadata.xml")
+            );
+        } catch (MetadataException e) {
+            ex = new LibraryException(this.getClass(), e);
+        }
+
+        if (!dataman.getStoreProviderRegister().exits(NAME)) {
+            dataman.registerStoreProviderFactory(new H2SpatialStoreProviderFactory());
+        }
+
+        if (!dataman.getServerExplorerRegister().exits(NAME)) {
+            dataman.registerServerExplorerFactory(new H2SpatialExplorerFactory());
+        }
+        if (ex != null) {
+            throw ex;
+        }
+    }
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialSQLBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialSQLBuilder.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialSQLBuilder.java	(revision 43377)
@@ -0,0 +1,376 @@
+package org.gvsig.fmap.dal.store.h2;
+
+import java.sql.PreparedStatement;
+import java.text.MessageFormat;
+import java.util.ArrayList;
+import java.util.Date;
+import java.util.List;
+import org.gvsig.fmap.dal.DataTypes;
+import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.FeatureType;
+import org.gvsig.fmap.dal.feature.spi.FeatureProvider;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
+import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
+import org.gvsig.fmap.geom.Geometry;
+
+public class H2SpatialSQLBuilder extends JDBCSQLBuilderBase {
+
+    private final H2SpatialHelper helper;
+
+    public H2SpatialSQLBuilder(H2SpatialHelper helper) {
+        super();
+        
+        this.helper = helper;
+        
+        //
+        // H2/H2GIS SQL functions reference list
+        //
+        // http://www.h2database.com/html/functions.html
+        // http://www.h2gis.org/docs/1.3/functions/
+        //
+        // http://www.h2database.com/html/grammar.html
+        //
+        // http://www.h2database.com/html/datatypes.html
+        //
+        //
+        
+        config.set(SQLConfig.default_schema, "");
+        config.set(SQLConfig.support_schemas, false);
+        config.set(SQLConfig.allowAutomaticValues, true);
+        config.set(SQLConfig.geometry_type_support, this.helper.getGeometrySupportType());
+        config.set(SQLConfig.has_spatial_functions, this.helper.hasSpatialFunctions());
+
+        config.remove_functionality(SQLConfig.DELETE_GEOMETRY_COLUMN_FROM_TABLE_schema_table);
+        config.remove_functionality(SQLConfig.DELETE_GEOMETRY_COLUMN_FROM_TABLE_table);
+         
+//        config.set(SQLConfig.UPDATE_TABLE_STATISTICS_table,"ANALYZE TABLE {0} SAMPLE_SIZE 0");
+        config.set(SQLConfig.UPDATE_TABLE_STATISTICS_table,"ANALYZE SAMPLE_SIZE 0");
+
+        config.set(SQLConfig.ST_GeomFromEWKB, "GeomFromWKB({0}, {1})");
+        config.set(SQLConfig.ST_AsEWKB, "AsWKB(({0}))");        
+        
+        config.set(SQLConfig.lcase, "LOWER({0})");
+        config.set(SQLConfig.ucase, "UPPER({0})");
+        config.set(SQLConfig.operator_ILIKE, "({0}) ILIKE ({1})");
+        config.set(SQLConfig.isNull, "( ({0}) IS NULL )");
+        config.set(SQLConfig.notIsNull, "( ({0}) IS NOT NULL )");
+
+        config.set(SQLConfig.type_boolean, "BOOLEAN");
+        config.set(SQLConfig.type_byte, "TINYINT");
+        config.set(SQLConfig.type_bytearray, "TINYINT");
+        config.set(SQLConfig.type_geometry, "GEOMETRY");
+        config.set(SQLConfig.type_char, "CHAR");
+        config.set(SQLConfig.type_date, "DATE");
+        config.set(SQLConfig.type_double, "DOUBLE"); 
+        config.set(SQLConfig.type_numeric_p, "DECIMAL({0})");
+        config.set(SQLConfig.type_numeric_ps, "DECIMAL({0},{1})");
+        config.set(SQLConfig.type_bigdecimal, "DOUBLE");
+        config.set(SQLConfig.type_float, "REAL");
+        config.set(SQLConfig.type_int, "INTEGER");
+        config.set(SQLConfig.type_long, "BIGINT");
+        config.set(SQLConfig.type_string, "VARCHAR");
+        config.set(SQLConfig.type_string_p, "VARCHAR({0})");
+        config.set(SQLConfig.type_time, "TIME");
+        config.set(SQLConfig.type_timestamp, "TIMESTAMP");
+        config.set(SQLConfig.type_version, "VARCHAR");
+        config.set(SQLConfig.type_URI, "VARCHAR");
+        config.set(SQLConfig.type_URL, "VARCHAR");
+        config.set(SQLConfig.type_FILE, "VARCHAR");
+        config.set(SQLConfig.type_FOLDER, "VARCHAR");        
+    }
+
+    public class SpatiaLiteTableNameBuilderBase extends TableNameBuilderBase {
+
+        @Override
+        public boolean has_schema() {
+            return false;
+        }
+
+        @Override
+        public boolean has_database() {
+            return false;
+        }
+        
+    }
+    
+    protected class SpatiaLiteCreateTableBuilder extends CreateTableBuilderBase {
+
+        @Override
+        public List<String> toStrings() {
+
+            List<String> sqls = new ArrayList<>();
+            StringBuilder builder = new StringBuilder();
+
+            builder.append("CREATE TABLE ");
+            builder.append(this.table.toString());
+            builder.append(" (");
+            boolean first = true;
+            for (ColumnDescriptorBuilder column : columns) {
+
+                if (first) {
+                    first = false;
+                } else {
+                    builder.append(", ");
+                }
+                builder.append(identifier(column.getName()));
+                builder.append(" ");
+                builder.append(sqltype(column.getType(), column.getPrecision(), column.getSize()));
+                if( column.isGeometry() ) {
+                    int h2geomtype = getH2SpatialGeometryTypeFromGeometryType(
+                        column.getGeometryType(), 
+                        column.getGeometrySubtype()
+                    );
+                    if( h2geomtype>0 ) {
+                        String constaint;
+                        if( this.table().has_schema() ) {
+                            constaint = MessageFormat.format(
+                                "CHECK ({0}.ST_GEOMETRYTYPECODE({1}) = {2})",
+                                this.table().getSchema(),
+                                column.getName(),
+                                h2geomtype
+                            );                            
+                        } else {
+                            constaint = MessageFormat.format(
+                                "CHECK (ST_GEOMETRYTYPECODE({0}) = {1})",
+                                column.getName(),
+                                h2geomtype
+                            );
+                        }
+                        builder.append(constaint);
+                    }
+                } else {
+                    if (column.isPrimaryKey()) {
+                        builder.append(" PRIMARY KEY");
+                    }
+                    if( column.isAutomatic() ) {
+                        builder.append(" AUTO_INCREMENT");
+                    }
+                    if (column.getDefaultValue() == null) {
+                        if (column.allowNulls()) {
+                            builder.append(" DEFAULT NULL");
+                        }
+                    } else {
+                        if( column.getType() == DataTypes.DATE ) {
+                            builder.append(" DEFAULT ( date('");
+                            builder.append(column.getDefaultValue().toString());
+                            builder.append("') )");
+                        } else {
+                            builder.append(" DEFAULT '");
+                            builder.append(column.getDefaultValue().toString());
+                            builder.append("'");
+                        }
+                }
+                }
+                if (!column.allowNulls()) {
+                    builder.append(" NOT NULL");
+                }
+            }
+            builder.append(" )");
+            sqls.add(builder.toString());
+            
+            return sqls;
+        }
+        
+        public int getH2SpatialGeometryTypeFromGeometryType(int geomtype, int geomsubtype) {
+            //
+            // https://github.com/orbisgis/h2gis/wiki/1.-Spatial-data#geometry-columns-view
+            //
+            
+            switch(geomtype) {
+            case Geometry.TYPES.POINT:
+                return 1;
+            case Geometry.TYPES.MULTIPOINT:
+                return 4;
+            case Geometry.TYPES.LINE:
+                return 2;
+            case Geometry.TYPES.MULTILINE:
+                return 5;
+            case Geometry.TYPES.POLYGON:
+                return 3;
+            case Geometry.TYPES.MULTIPOLYGON:
+                return 6;
+            default:
+                return -1;
+            }
+        }
+    }
+
+    public class SpatiaLiteSelectBuilderBase extends SelectBuilderBase {
+        
+        protected boolean isValid(StringBuilder message) {
+            if( message == null ) {
+                message = new StringBuilder();
+            }
+            if( this.has_offset() && !this.has_order_by() ) {
+                // Algunos gestores de BBDD requieren que se especifique un
+                // orden para poder usar OFFSET. Como eso parece buena idea para
+                // asegurar que siempre tengamos los mismo resultados, lo exijimos
+                // siempre.
+                message.append("Can't use OFFSET without an ORDER BY.");
+                return false;
+            }
+            return true;
+        }        
+        
+        @Override
+        public String toString() {
+            // SpatiaLite requiere que si se especifica OFFSET deba especificarse
+            // LIMIT obligatoriamente. Se le puede poner un LIMIT -1 cuando 
+            // queramos un OFFSET sin especificar un LIMIT.
+            StringBuilder builder = new StringBuilder();
+            if( !isValid(builder) ) {
+                throw new IllegalStateException(builder.toString());
+            }
+            builder.append("SELECT ");
+            if( this.distinct ) {
+                builder.append("DISTINCT ");
+            }
+            boolean first = true;
+            for (SelectColumnBuilder column : columns) {
+                if (first) {
+                    first = false;
+                } else {
+                    builder.append(", ");
+                }
+                builder.append(column.toString());
+            }
+
+            if ( this.has_from() ) {
+                builder.append(" FROM ");
+                builder.append(this.from.toString());
+            }
+            if ( this.has_where() ) {
+                builder.append(" WHERE ");
+                builder.append(this.where.toString());
+            }
+            
+            if( this.has_order_by() ) {
+                builder.append(" ORDER BY ");
+                first = true;
+                for (OrderByBuilder item : this.order_by) {
+                    if (first) {
+                        first = false;
+                    } else {
+                        builder.append(", ");
+                    }
+                    builder.append(item.toString());                    
+                }   
+            }
+            
+            if ( this.has_limit() && this.has_offset() ) {
+                builder.append(" LIMIT ");
+                builder.append(this.limit);
+                builder.append(" OFFSET ");
+                builder.append(this.offset);
+                
+            } else if ( this.has_limit()) {
+                builder.append(" LIMIT ");
+                builder.append(this.limit);
+
+            } else if ( this.has_offset() ) {
+                builder.append(" LIMIT -1 OFFSET ");
+                builder.append(this.offset);    
+            }
+            return builder.toString();
+
+        }
+    }
+
+    @Override
+    public String bytearray(byte[] data) {
+        // SpatiaLite usa un formato diferencte para especificar un array de 
+        // bytes. En lugar de 0x... usa x'...' .
+        StringBuilder builder = new StringBuilder();
+        builder.append("x'");
+        for (byte abyte : data) {
+            int v = abyte & 0xff;
+            builder.append(String.format("%02x", v));
+        }
+        builder.append("'");
+        return builder.toString();
+    }
+
+    @Override
+    public Object sqlgeometrydimension(int type, int subtype) {
+        //'XY' or 2: 2D points, identified by X and Y coordinates
+        //'XYM': 2D points, identified by X and Y coordinates. Each point stores an M-value (measure) as well
+        //'XYZ' or 3: 3D points, identified by X, Y and Z coordinates
+        //'XYZM' or 4: 3D points, identified by X, Y and Z coordinates. Each point stores an M-value (measure) as well
+        switch(subtype) {
+            case Geometry.SUBTYPES.GEOM2D:
+            default:
+                return "XY";
+            case Geometry.SUBTYPES.GEOM2DM:
+                return "XYM";
+            case Geometry.SUBTYPES.GEOM3D:
+                return "XYZ";
+            case Geometry.SUBTYPES.GEOM3DM:
+                return "XYZM";
+        }
+    }
+
+    public H2SpatialHelper getHelper() {
+        return this.helper;
+    }
+    
+    @Override
+    public void setParameters(PreparedStatement st, FeatureProvider feature) {
+        try {
+            FeatureType featureType = feature.getType();
+            List<Object> values = new ArrayList<>();
+            for (Parameter parameter : this.getParameters()) {
+                if (parameter.is_constant()) {
+                    values.add(parameter.getValue());
+                } else {
+                    String name = parameter.getName();
+                    FeatureAttributeDescriptor descriptor = featureType.getAttributeDescriptor(name);
+                    switch( descriptor.getType() ) {
+                    case DataTypes.DATE:
+                        Date value = (Date)(feature.get(name));
+                        if( value == null ) {
+                            values.add(null);
+                        } else {
+                            values.add(value.getTime());
+                        }
+                        break;
+                    case DataTypes.GEOMETRY:
+                        Geometry geom = this.getHelper().forceGeometryType(
+                            descriptor.getGeomType(),
+                            (Geometry)(feature.get(name))
+                        );
+                        values.add(geom);
+                        break;
+                    default:
+                        values.add(feature.get(name));
+                        break;
+                    }
+                }
+            }
+            JDBCUtils.setObjects(st, values, this.geometry_support_type());
+        } catch (Exception ex) {
+            String f = "unknow";
+            try {
+                f = feature.toString();
+            } catch (Exception ex2) {
+                // Do nothing
+            }
+            throw new RuntimeException("Can't set parameters to prepared statement from the feature (" + f + ")", ex);
+        }
+    }
+            
+    @Override
+    protected TableNameBuilder createTableNameBuilder() {
+        return new SpatiaLiteTableNameBuilderBase();
+    }
+    
+    @Override
+    protected CreateTableBuilder createCreateTableBuilder() {
+        return new SpatiaLiteCreateTableBuilder();
+    }
+
+    @Override
+    protected SelectBuilder createSelectBuilder() {
+        return new SpatiaLiteSelectBuilderBase();
+    }
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialExplorerFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialExplorerFactory.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialExplorerFactory.java	(revision 43377)
@@ -0,0 +1,43 @@
+
+package org.gvsig.fmap.dal.store.h2;
+
+import org.gvsig.fmap.dal.DataServerExplorerParameters;
+import org.gvsig.fmap.dal.exception.InitializeException;
+import org.gvsig.fmap.dal.spi.DataServerExplorerProviderServices;
+import org.gvsig.fmap.dal.store.jdbc.JDBCConnectionParameters;
+import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCServerExplorer;
+import org.gvsig.fmap.dal.store.jdbc2.impl.JDBCServerExplorerFactory;
+
+
+public class H2SpatialExplorerFactory extends JDBCServerExplorerFactory {
+
+    public H2SpatialExplorerFactory() {
+        super(
+                H2SpatialLibrary.NAME,
+                "H2Spatial"
+        );
+    }
+
+    @Override
+    public JDBCServerExplorer create(
+            DataServerExplorerParameters parameters, 
+            DataServerExplorerProviderServices providerServices
+        ) throws InitializeException {
+        JDBCHelper helper = new H2SpatialHelper((JDBCConnectionParameters) parameters);
+        JDBCServerExplorer server = helper.createServerExplorer(
+                (JDBCServerExplorerParameters) parameters, 
+                providerServices
+        );
+        return server;
+    }
+        
+
+    @Override
+    public JDBCServerExplorerParameters createParameters() {
+        JDBCServerExplorerParameters params = new H2SpatialExplorerParameters();
+        return params;    
+    }
+    
+}
